Subject: Re: bug#54914: 28.1.50; Unable to form Brahmi conjuncts in Emacs

From: Eli Zaretskii <[email-masked]>
Date: Sat, 16 Apr 2022 19:29:36 +0300

> From: समीर सिंह Sameer Singh <[email-masked]>
> Date: Sat, 16 Apr 2022 19:04:15 +0530
> Cc: Robert Pluim <[email-masked]>, [email-masked]
> 
> Sorry for not including the codepoints, here they are:
> hb-conjuncts-maatra.png & emacs-conjuncts-maatra.png from top to bottom
> 1. \011013 \011046 \01102C \011038(𑀓𑁆𑀬𑀸)
> 2. \011013 \011046 \01102E \011043 (𑀓𑁆𑀮𑁃)
> 3. \011032 \011046 \01102C \01103B(𑀲𑁆𑀬𑀻)
> 
> hb-tri-conjuncts.png & emacs-tri-conjuncts.png from top to bottom
> 1. \011013 \011046 \01102E \011046 \01102F (𑀓𑁆𑀮𑁆𑀯)
> 2. \01102F \011046 \01102C \011046 \01102F (𑀯𑁆𑀬𑁆𑀯)
> 3. \01102B \011046 \011027 \011046 \01102D (𑀫𑁆𑀧𑁆𑀭)
> 
>  Also, where do you see the shaping rules that support those
>  combinations?  I didn't find them in the Unicode Standard or anywhere
>  else I've read about Brahmi.  What are your sources? 
> 
>  
> Languages like Sanskrit has three or more than three conjuncts. They are supported in scripts like
> devanagari (https://en.wikipedia.org/wiki/Devanagari_conjuncts#Tri-_and_tetra-consonantal_conjuncts)
> So brahmi should be able to support them too.
> I could find one example in the "Proposal to include Brahmi in Unicode" document
> (https://www.unicode.org/L2/L2003/03249r-brahmi-proposal.pdf) (Page 5, 1st image, 3rd character)

I've attempted to enhance the composition rules, please try the latest
master.  They don't always work on my system, but I think that's
because of the font I use and perhaps also the relatively old version
of HarfBuzz I have here.